﻿using TMPro;
using UnityEngine;

namespace Code.Entity
{
    public class Enemy2 : Enemy
    {

        private bool _loadSpecial;
        
        void Start()
        {
            _loadSpecial = false;
            this.specialFailureRate = 20;
            _animator = this.gameObject.GetComponent<Animator>();
        }
        
        public override void Attack(Entity entity)
        {
            Debug.Log(this.attackPower);
            entity.InflictDamage(this.attackPower);
        }

        public override string UseSpecial(Entity entity)
        {
            _loadSpecial = false;
            if (Random.Next(0, 100) <= this.specialFailureRate)
            {
                Debug.Log("Hilfe das Special ding is fehlgeschlagen!");
                return "Attack Failed!";
            }
            if (entity.InflictDamage(this.attackPower * 3, isSpecial: true))
            {
                return "Attack Successful!";
            }

            return "Attack Failed"!;
        }

        public override bool IsDefending(bool isSpecial)
        {
            return false;
        }

        public override string HandleTurn(Entity entity, TextMeshProUGUI text)
        {
            if (_loadSpecial)
            { 
                text.text = this.UseSpecial(entity);
                return "Attack";
            }
            
            var randomNum = this.Random.Next(0, 100);

            if (randomNum <= 40)
            {
                _loadSpecial = true;
                text.text = "Charging Special Attack!...";
                Debug.Log("Charging Special!...");
                return null;
            } else
            {
                this.Attack(entity);
                Debug.Log("Attacking");
                return "Attack";
            }
        }
    }
}