﻿
using System;

namespace Code.Entity
{
    public class Player : Entity
    {

        private bool _defending; 
        
        void Start()
        {
            this.name = "Player";
            this.attackPower = 1;
            this.health = 10;
            this.healPower = 1;
            this.defendFailureRate = 10f;
            this.specialFailureRate = 1f;
            this._defending = false;
        }
        
        public override void Attack(Entity entity)
        {
            entity.InflictDamage(this.attackPower);
        }

        public override string UseSpecial(Entity entity)
        {
            var enemy = (Enemy)entity;
            enemy.InflictDamage(this.attackPower * 10, isSpecial: true);
            return "";
        }

        public override bool IsDefending(bool isSpecial)
        {
            if (isSpecial)
            {
                if (Random.Next(0, 100) > defendFailureRate && _defending)
                {
                    _defending = false;
                    return true;
                } else if (_defending)
                {
                    _defending = false;
                }

                return false;
            }

            return false;
        }

        public void SetDefending()
        {
            _defending = true;
        }
    }
}